
MEMORY 
{
	FLASH	: ORIGIN = 0x00000000, LENGTH = 32K
	RAM	    : ORIGIN = 0x40000000, LENGTH = 8K
}

__stack_end__ = 0x40000000 + 8K - 4;

SECTIONS 
{
	. = 0;

	.startup :
    {
        *(.startup)
    } >FLASH

    . = ALIGN(4);

    .ctors :
    {
        __ctors_start__ = .;
        *(.init_array)
        /* *(.ctors) */
        __ctors_end__ = .;
        __dtors_start__ = .;
        /* *(.dtors) */
        *(.fini_array)
        __dtors_end__ = .;

        KEEP(SORT(*)(.init_array))
        KEEP(SORT(*)(.fini_array))
        /*
        KEEP(SORT(*)(.dtors))
        KEEP(SORT(*)(.ctors))
        */
    }

    . = ALIGN(4);

	.text :
	{
        *(.text)
        *(.rodata) 
        *(.rodata*)
		*(.glue_7)
		*(.glue_7t)
	} >FLASH

    . = ALIGN(4);

	__end_of_text__ = .;

	.data : 
	{
		__data_beg__ = .;
		__data_beg_src__ = __end_of_text__;
		*(.data)
		__data_end__ = .;
	} >RAM AT>FLASH

	.bss : 
	{
		__bss_beg__ = .;
		*(.bss)
	} >RAM

	/* Align here to ensure that the .bss section occupies space up to
	_end.  Align after .bss to ensure correct alignment even if the
	.bss section disappears because there are no input sections.  */
	. = ALIGN(32 / 8);
	_bss_end__ = . ; __bss_end__ = . ; __end__ = . ;

}
	. = ALIGN(32 / 8);
	_end = .;
	
	PROVIDE (end = .);


