#include "config.h"
#include <inttypes.h>
#include "uart.h"


#define LED1 (1<<4)
#define LED2 (1<<5)
#define LED3 (1<<6)
#define LED4 (1<<7)
#define LED_MASK (LED1 | LED2 | LED3 | LED4)

#define WAIT { int i; for(i=0; i<800000; i++) asm volatile (" nop "); }


const uint32_t decpower[] = {
    1000000000,
    100000000,
    10000000,
    1000000,
    100000,
    10000,
    1000,
    100,
    10,
};

char* itoa32(uint32_t val, char* s)
{
    uint32_t tmp;
    char atmp;
    unsigned int i;

    for(i=0; i < sizeof(decpower)/sizeof(decpower[0]); i++)
    {
        tmp = decpower[i];
        atmp = '0';
        while(val >= tmp)
        {
            atmp++;
            val -= tmp;
        }
        if(atmp > '0')
            *s++ = atmp;
    }
    *s++ = val + '0';
    *s = 0;
    return s;
}

/*-----------------------------------------------------------*/

int main(void)
{
    char scnt[64];
    FIO0SET = LED_MASK;
    FIO0DIR |= LED_MASK;

#if (UART0_SUPPORT)
	uart0Init(UART_BAUD(HOST_BAUD_U0), UART_8N1, UART_FIFO_8); // setup the UART
#endif
#if (UART1_SUPPORT)
	uart1Init(UART_BAUD(HOST_BAUD_U1), UART_8N1, UART_FIFO_8); // setup the UART
#endif

#if ( UART0_SUPPORT )
	uart0Puts("Hello from UART0\r\n");
#endif

    int cnt = 0;
    for(;;)
    {
        FIO0CLR = LED1;
        WAIT;
        FIO0CLR = LED2;
        WAIT;
        FIO0CLR = LED3;
        WAIT;
        FIO0CLR = LED4;
        WAIT;
        FIO0SET = LED_MASK;
        WAIT;

#if ( UART0_SUPPORT )
        itoa32(cnt, scnt);
        uart0Puts("Counter ");
        uart0Puts(scnt);
        uart0Puts("\r\n");
#endif

        cnt++;
    }
	return 0; 
}
/*-----------------------------------------------------------*/







